// Copyright 2025 Steven Le Rouzic
//
// SPDX-License-Identifier: BSD-3-Clause

#define VULKAN_GLOBAL_FNS \
    FN(vkEnumerateInstanceVersion) \
    FN(vkCreateInstance)
    
#define VULKAN_INSTANCE_FNS \
    FN(vkDestroyInstance) \
    FN(vkDestroySurfaceKHR) \
    FN(vkEnumeratePhysicalDevices) \
    FN(vkGetPhysicalDeviceProperties) \
    FN(vkGetPhysicalDeviceQueueFamilyProperties) \
    FN(vkCreateDevice) \
    FN(vkGetDeviceProcAddr) \
    FN(vkGetPhysicalDeviceSurfaceCapabilitiesKHR) \
    FN(vkGetPhysicalDeviceSurfaceFormatsKHR) \
    FN(vkGetPhysicalDeviceSurfacePresentModesKHR)

#define VULKAN_DEVICE_FNS \
    FN(vkDestroyDevice) \
    FN(vkGetDeviceQueue) \
    FN(vkCreateSwapchainKHR) \
    FN(vkDestroySwapchainKHR) \
    FN(vkGetSwapchainImagesKHR) \
    FN(vkAcquireNextImageKHR) \
    FN(vkQueuePresentKHR) \
    FN(vkCreateCommandPool) \
    FN(vkDestroyCommandPool) \
    FN(vkResetCommandPool) \
    FN(vkDeviceWaitIdle) \
    FN(vkAllocateCommandBuffers) \
    FN(vkResetCommandBuffer) \
    FN(vkFreeCommandBuffers) \
    FN(vkBeginCommandBuffer) \
    FN(vkEndCommandBuffer) \
    FN(vkQueueSubmit) \
    FN(vkCreateSemaphore) \
    FN(vkDestroySemaphore) \
    FN(vkCmdPipelineBarrier) \
    FN(vkCmdClearColorImage)
